<?php

namespace App\Middleware;

class OwnerMiddleware extends Middleware
{
	public function __invoke($request, $response, $next)
	{
        $route = $request->getAttribute('route');
        if (!$this->container->auth->isAdmin() && !$this->container->auth->isOwner($route->getArguments('bookId'))) {
			$this->container->session->getFlashBag()->add('error', 'Not Authorized');
            return $response->withRedirect('/books');
		}

		$response = $next($request, $response);

		return $response;
	}
}