<?php
namespace App\Model;

class Auth
{
  protected $session;
  protected $user;

  function __construct($session, $user)
  {
    $this->session = $session;
    $this->user = $user;
  }
  function isAuthenticated()
  {
    return $this->session->get('auth_logged_in', false);
  }

  function isAdmin()
  {
    if (!$this->isAuthenticated()) {
      return false;
    }
    
    return $this->session->get('auth_roles') === 1;
  }

  function isOwner($ownerId)
  {
    if (!$this->isAuthenticated()) {
      return false;
    }
    
    
    return $ownerId == $this->session->get('auth_user_id');
  }

  function getAuthenticatedUser()
  {
    
    return $this->user->findUserById($this->session->get('auth_user_id'));
  }

  function saveUserSession($user)
  {
    
    $this->session->set('auth_logged_in', true);
    $this->session->set('auth_user_id', (int) $user['id']);
    $this->session->set('auth_roles', (int) $user['role_id']);
    
    $this->session->getFlashBag()->add('success', 'Successfully Logged In');
  }
}