<?php
namespace App\Model;

/*
 * Functions to interface with `user` table
 */
class User
{
    protected $database;

    function __construct($database)
    {
        $this->database = $database;
    }

    function getAllUsers()
    {
        try {
            $query = "SELECT * FROM users";
            $stmt = $this->database->prepare($query);
            $stmt->execute();
            return $stmt->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    function findUserByUsername($username)
    {
        try {
            $query = "SELECT * FROM users WHERE username = :username";
            $stmt = $this->database->prepare($query);
            $stmt->bindParam(':username', $username);
            $stmt->execute();
            return $stmt->fetch();

        } catch (\Exception $e) {
            throw $e;
        }
    }
    function findUserById($userId)
    {
        try {
            $query = "SELECT * FROM users WHERE id = :userId";
            $stmt = $this->database->prepare($query);
            $stmt->bindParam(':userId', $userId);
            $stmt->execute();
            return $stmt->fetch();

        } catch (\Exception $e) {
            throw $e;
        }
    }
    function createUser($username, $password)
    {
        try {
            $query = "INSERT INTO users (username, password, role_id) VALUES (:username, :password, 2)";
            $stmt = $this->database->prepare($query);
            $stmt->bindParam(':username', $username);
            $stmt->bindParam(':password', $password);
            $stmt->execute();
            return $this->findUserByUsername($username);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    function updatePassword($password, $userId)
    {
        try {
            $query = 'UPDATE users SET password = :password WHERE id = :userId';
            $stmt = $this->database->prepare($query);
            $stmt->bindParam(':password', $password);
            $stmt->bindParam(':userId', $userId);
            $stmt->execute();
            if ($stmt->rowCount() > 0) {
            return true;
            } else {
            return false;
            }
        } catch (\Exception $e) {
            throw $e;
        }

        return true;
    }

    function changeRole($userId, $roleId)
    {
        try {
            $query = "UPDATE users SET role_id = :roleId WHERE id = :userId";
            $stmt = $this->database->prepare($query);
            $stmt->bindParam(':roleId', $roleId);
            $stmt->bindParam(':userId', $userId);
            $stmt->execute();
            return $this->findUserById($userId);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}