<?php
namespace App\Model;

/**
 * Functions to interface with `votes` table
 */
class Vote
{
    protected $database;

    function __construct($database)
    {
        $this->database = $database;
    }

    function getUserVote($bookId, $userId = 0) 
    {
        try {
            $query = "SELECT value FROM votes "
            . " WHERE book_id = :bookId"
            . " AND user_id = :userId";
            $stmt = $this->database->prepare($query);
            $stmt->bindParam(':bookId', $bookId);
            $stmt->bindParam(':userId', $userId);
            $stmt->execute();
            return (int) $stmt->fetchColumn();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    function vote($bookId, $score, $userId = 0)
    {
        if ($this->clearVote($bookId, $userId)) {
            return true;
        }

        try {
            $query = 'INSERT INTO votes (book_id, user_id, value) VALUES (:bookId, :userId, :score)';
            $stmt = $this->database->prepare($query);
            $stmt->bindParam(':bookId', $bookId);
            $stmt->bindParam(':userId', $userId);
            $stmt->bindParam(':score', $score);
            $stmt->execute();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    function clearVote($bookId, $userId)
    {
        try {
            $query = "DELETE FROM votes WHERE book_id = :bookId AND user_id = :userId";
            $stmt = $this->database->prepare($query);
            $stmt->bindParam(':bookId', $bookId);
            $stmt->bindParam(':userId', $userId);
            $stmt->execute();
            return $stmt->rowCount();
        } catch (\Exception $e) {
            throw $e;
        }
    }
}