<?php
// DIC configuration

$container = $app->getContainer();

// view renderer
$container['renderer'] = function ($c) {
    $settings = $c->get('settings')['renderer'];
    $templateVariables = [
        'session'=>$c->session,
        'auth'=>$c->auth,
    ];
    return new Slim\Views\PhpRenderer($settings['template_path'], $templateVariables);
};

// session
$container['session'] = function ($c) {
    $session = new \Symfony\Component\HttpFoundation\Session\Session();
    return $session;
};

// database
$container['db'] = function($c) {
    $db = $c->get('settings')['db'];
    $pdo = new PDO($db['dsn'].':'.$db['database'], $db['username'], $db['password'], $db['options']);

    return $pdo;
};

// book
$container['book'] = function ($c) {
    $book = new App\Model\Book($c->get('db'));
    return $book;
};

// user
$container['user'] = function ($c) {
    $user = new App\Model\User($c->get('db'));
    return $user;
};

// vote
$container['vote'] = function ($c) {
    $vote = new App\Model\Vote($c->get('db'));
    return $vote;
};

// auth
$container['auth'] = function ($c) {
    $auth = new App\Model\Auth($c->get('session'), $c->get('user'));
    return $auth;
};